//TODO: v3.
//get rid of write button
//next/prev buttons
// home/end keys phenomenon?
// font in radio buttons?
//error checking in export
//overwrite allowed in export?
//add text file import
// test test test

//ideas:
//v4 - rewrite with new Preferences, Tree and Image classes - yoip!
// towards: loading progress, tidier code, search, rotate images, widget rearrangement
//          (see below)
//get Fl_Native_File_Chooser current
//rotate images
//make prefs a subwindow?
//make prefs subclass for easier access to values/bool?
//write current caption on quit?
//caption written status
//disable write button until changed?
//status lights (caption location,etc.)?
//select caption source
//allow hide browser
//category/rating drop lists?
//widget rearrangement dep on which are shown
//make new browser?
//what if lastpic doesn't exist? -doesn't cause such a problem, check for it on load??
//file date/time stamp if no EXIF
//can image be released more often?
//tidy slash checks? -there's only four
//loading progress?
//quote support captionfile path?
//search??
//add help? at least make docs
//add about and credits

//network testing -some done, made "//" hack and fileopen check
//mac testing

//done, v3:
//add text file export -done
//check update caption -looks good
//ttrn: how should messages be sent? (error conditions, etc.) -not gonna touch this in v3! rewrite v4 from near bottom.
//ttrn: how often are images loaded (set_hilight, etc.) - done, removed set_hilight from bottom of load_dir
//ttrn: started moving preferences to be copied into idv. methods, would rather subclass preferences
//tidy the rat's nest (ttrn): tidy preferences open -done, prefs created once, pointer passed to PrefWindow class
//fix writing caption if no pictures loaded. -done, via checking filecount, extra if needed for "all done" fl_message_box
//reload dir display vs. last file inconsistency - done, now saves path before reload and sets after
//hack-around set_hilight -tried, giving up for now
//finish update prefs - done
//error copage -doneish, made current not beautiful
//move db store -done, stores in prefs->getUserdataPath()
//update caption on pref change/reload dir -done
//clear caption only if pic changed w/out enter -done
//keep reading from text files -done, with lookcatrate "add"-hacked improvement
//update prefs -started
// file chooser -done
// expect category -done
//switch to SQLite db -done

//underlying problems:
//Fl_Native_File_Chooser filters ( windows ("*") and return file append filter?)
//files found label redrawing problems - not just copy_label
// Win32 filters

//browser position (esp after switch roots)  -sort of done (not after reloads due to two line glitch)
//two blank lines from: tree->set_hilighted( tree->first_leaf() );
//tree scrolling
//side note: flu_file chooser favorites use prefs in My Documents

//Fl_Shared_Image explosion ( Premature end of JPEG file ) -done, test










#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Round_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Shared_Image.H>
#include <FL/Fl_File_Input.H>
#include <FL/filename.H>
#include <FL/fl_ask.H>
#include <FLU/Flu_Tree_Browser.h>
#include "Fl_Image_Display.H"
#include <FL/Fl_Native_File_Chooser.H>
#include <FL/Fl_Preferences.H>
#include <fstream>
#if defined(WIN32)
 #include <FL/x.H>
#else                  //what about Mac?
 #include <FL/Fl_Pixmap.H>
 #include "icon.xpm"
#endif

#include "EXIF.H" //Davide Pizzolato
#include <sqlite3.h>
#include <iostream>
using namespace std;

class nWindow : public Fl_Double_Window {
 Fl_Preferences* prefs;
 sqlite3 *db;
 int filecount;                   //needed?! -write_it() now checks
 char defcatr[255];               //size?! static alloc?

 int lookcatrate;		  //should be bool
 bool current_written;
 Flu_Tree_Browser* tree;
 Fl_Image_Display* display;
 Fl_Menu_Bar* menub;
 Fl_Input* pathdisp;
 Fl_Input* datedisp;
 Fl_Input* expdisp;
 Fl_Input* resdisp;
 Fl_Input* caption;
 Fl_Input* catrate;
 Fl_Input* root;
 Fl_Button* saver;
 Fl_Button* reload;
 Fl_Shared_Image* dispimg;
 static void load_dir_(Fl_Widget*w,void*d) { ((nWindow*)d)->load_dir(); }
 void load_dir();
 void out_dir(char*);
 static void tree_cb_(Fl_Widget*w,void*d) { ((nWindow*)d)->tree_cb(); }
 void tree_cb();
 int pull_caption();
 int do_pull_db();
 int do_pull_cfr();
 static void quit_cb_(Fl_Widget*w,void*d) { ((nWindow*)d)->quit_cb(); }
 void quit_cb();
 static void set_dir_(Fl_Widget*w,void*d) { ((nWindow*)d)->set_dir(); }
 void set_dir();
 static void set_prefs_(Fl_Widget*w,void*d) { ((nWindow*)d)->set_prefs(); }
 void set_prefs();
 void apply_prefs();
 int open_db();
 static void write_it_(Fl_Widget*w,void*d) { ((nWindow*)d)->write_it(); }
 int write_it();
 static void export_cb_(Fl_Widget*w,void*d) { ((nWindow*)d)->export_cb(); }
 void export_cb();
 void setplaino(Fl_Widget*w) { w->color(FL_GRAY); w->box(FL_FLAT_BOX); w->set_output(); }
 char* add_rootvalue(char*, const char*);
 void set_widgets();
public:
 nWindow (int w, int h, char*l, int argc, char*argv[]) : Fl_Double_Window (w,h,l) {
  char lastdir[FL_PATH_MAX];
  char lastpic[FL_PATH_MAX];

  fl_register_images();
  dispimg=0;
  begin();
  menub=new Fl_Menu_Bar(0,0,w,30);
  tree=new Flu_Tree_Browser(5,35,200,400-61);
  reload=new Fl_Button(5,375,50,25,"Reload");
  root=new Fl_Input(210,375,385,25);
  display=new Fl_Image_Display(210,35,385,250);
  pathdisp=new Fl_Input(210,285,385,20);
  datedisp=new Fl_Input(210,305,150,20);
  expdisp=new Fl_Input(360,305,235,20);
  resdisp=new Fl_Input(210,325,385,20);
  caption=new Fl_Input(210,350,305,25);
  catrate=new Fl_Input(515,350,40,25);
  saver=new Fl_Button(555,350,40,25,"Write");
  end();
#if defined(WIN32)
  icon((char*)LoadImage(fl_display,MAKEINTRESOURCE(101),IMAGE_ICON,16,16,LR_DEFAULTCOLOR));
#else                                         //what about Mac?
  Fl_Pixmap icon_pm(flQuickCap_icon_xpm);     //this is not the documented way. Beware.
  icon(icon_pm.data());                       //attempt to set Linux window icon. UNTESTED!!!
#endif

  prefs=new Fl_Preferences( Fl_Preferences::USER, "nvwuninc", "flcapt" );
  callback(quit_cb_,this);
  apply_prefs();
  set_widgets();
  prefs->get("lastdir",lastdir,"",sizeof(lastdir));
  prefs->get("lastpic",lastpic,"",sizeof(lastpic));
  root->value(lastdir);
  show(argc,argv);
  open_db();
  load_dir();
  if (strcmp(lastpic,"")) tree->set_hilighted(tree->find(lastpic)); 
  else tree->set_hilighted( tree->first_leaf() );
 }
};

int nWindow::open_db() {
 char db_path[FL_PATH_MAX];
 prefs->getUserdataPath(db_path, sizeof(db_path));
 strcat(db_path,"flcapt.db");
 int errc=sqlite3_open(db_path, &db);
 sqlite3_stmt *prepped=0;
 const char* ptail=0;
#define SQL_CHK "SELECT dir, file, caption, catrate FROM captions"
#define SQL_CRT "CREATE TABLE captions (dir, file UNIQUE, caption, catrate)"
 errc=sqlite3_prepare(db,SQL_CHK,strlen(SQL_CHK),&prepped,&ptail);
 sqlite3_finalize(prepped);
 if (errc==1) {                                         // probably no such table, so try creating it
  sqlite3_prepare(db,SQL_CRT,strlen(SQL_CRT),&prepped,&ptail);
  errc=sqlite3_step(prepped);
  sqlite3_finalize(prepped);
  return errc;
 }
 else return errc;
}

void nWindow::set_widgets() {
  menub->add("File",FL_ALT+'f',0,0,FL_SUBMENU);
  menub->add("File/Select root &directory...",FL_CTRL+'d',set_dir_,this);
  menub->add("File/E&xit",FL_CTRL+'x',quit_cb_,this);
  menub->add("Tools",FL_ALT+'t',0,0,FL_SUBMENU);
  menub->add("Tools/&Export captions...",FL_CTRL+'e',export_cb_,this);
  menub->add("Tools/&Show captions from...",FL_CTRL+'f',set_prefs_,this);
  menub->add("Tools/&Import captions...",FL_CTRL+'i',set_prefs_,this,FL_MENU_INACTIVE);
  tree->show_root(false);
  tree->show_branches(false);
  tree->selection_mode(FLU_SINGLE_SELECT);
  tree->selection_follows_hilight(true);
  tree->callback(tree_cb_,this);
  reload->callback(load_dir_,this);
  setplaino(root);
  root->align(FL_ALIGN_LEFT);
  display->set_gamma();
  setplaino(pathdisp);
  setplaino(datedisp);
  setplaino(expdisp);
  setplaino(resdisp);
  caption->callback(write_it_,this);
  caption->when(FL_WHEN_ENTER_KEY_ALWAYS);
  catrate->callback(write_it_,this);
  catrate->when(FL_WHEN_ENTER_KEY_ALWAYS);
  saver->callback(write_it_,this);
  resizable(display);
}

void nWindow::quit_cb() {
 prefs->set("lastpic", tree->find_path(tree->get_selected(1)) );
 prefs->set("lastdir",root->value());
 delete prefs;
 hide();
}

int nWindow::write_it() {
 if ( !saver->visible_r() ) return -1;
 if ( !filecount ) return -1;
 if ( !strcmp(root->value(),"") ) { resdisp->value("You must open a directory!"); pathdisp->value(""); root->value(""); expdisp->value(""); datedisp->value(""); return -1; }

 int errc=0;
 sqlite3_stmt *prepped=0;
 const char* ptail=0;

#define SQL_INS "INSERT OR REPLACE INTO captions (dir,file,caption,catrate) VALUES (?,?,?,?)"
 errc=sqlite3_prepare(db,SQL_INS,strlen(SQL_INS),&prepped,&ptail);
 if (errc!=SQLITE_OK) { fl_message("Database error (%s)!",sqlite3_errmsg(db)); return errc; };

 sqlite3_bind_text(prepped,1,root->value(),root->size(),SQLITE_TRANSIENT);
 sqlite3_bind_text(prepped,2,pathdisp->value(),pathdisp->size(),SQLITE_TRANSIENT);
 sqlite3_bind_text(prepped,3,caption->value(),caption->size(),SQLITE_TRANSIENT);
 sqlite3_bind_text(prepped,4,catrate->value(),catrate->size(),SQLITE_TRANSIENT);
 errc=sqlite3_step(prepped);
 if (errc!=SQLITE_DONE) { fl_message("Database error: (%s)!",sqlite3_errmsg(db)); return errc; };
 sqlite3_finalize(prepped);

 current_written=true;
 if ( tree->get_hilighted() ) {
  if ( tree->get_hilighted()->next_leaf() ) tree->set_hilighted( tree->get_hilighted()->next_leaf() );
  else fl_message("All done.\n(Now go do something else.)");
 }
 if (Fl::focus()==catrate) Fl::focus(caption);
 caption->position(0,strlen(caption->value()));
 
 return 0;
}

void nWindow::load_dir() {
 FILE* capfile;
 char happy[FL_PATH_MAX];
 char prev[FL_PATH_MAX];
 filecount=0;

 if ( !strcmp(root->value(),"") ) { set_dir(); return; }  // I am so bizarre.

 strcpy( prev, tree->find_path(tree->get_hilighted()) );

 strcpy (happy,root->value());
 strcat(happy,"/");
 tree->clear();
 out_dir(happy);

 sprintf(happy, "%d files found in", filecount);
 root->copy_label(happy);

 if (!filecount) { resdisp->value("No JPEG's or AVI's found in chosen directory."); pathdisp->value(root->value()); expdisp->value(""); datedisp->value(""); display->value(NULL); }
}

void nWindow::set_dir() {
 //char* chosen;
 //chosen=fl_dir_chooser("Load all images contained in directory", "");

 Fl_Native_File_Chooser fb(Fl_Native_File_Chooser::BROWSE_DIRECTORY);
 fb.title("All images found in directory and subdirectories will be loaded.");
 // !? use lastdir for starting directory?

 if (fb.show()==0) {
  root->value(fb.filename());
  load_dir();
  if ( tree->get_root()->first_leaf() ) tree->set_hilighted( tree->get_root()->first_leaf() );
 }
 pull_caption();
}

void nWindow::tree_cb() {
 if ( tree->callback_reason()!=FLU_HILIGHTED ) return;

 FILE* imgfile;
 EXIFINFO m_exifinfo;
 memset (&m_exifinfo,0,sizeof(EXIFINFO));
 char path[FL_PATH_MAX];                                // ??!! valid for tree browser?
 char exftmp[512];					// ??! right size?
 Cexif imgexif(&m_exifinfo);
 
 if ( !strncmp(root->value(),"//",2) || !strncmp(root->value(),"\\\\",2) ) {    //check for SMB names
  strcpy(path,"/");
  strcat(path,tree->find_path(tree->callback_node())+1);
 }
 else if ( root->index(0)=='/' ) strcpy(path,tree->find_path(tree->callback_node()));
 else strcpy(path,tree->find_path(tree->callback_node())+1); // for c:\ don't include initial /

 pathdisp->value(path+strlen(root->value()));
 if ( fl_filename_match(path,"*.avi") ) fl_filename_setext(path,".thm");

 imgfile=fopen(path,"rb");
 if (imgfile) { imgexif.DecodeExif(imgfile); fclose(imgfile); }
 else m_exifinfo.IsExif=false;
 if (!m_exifinfo.IsExif) { datedisp->value("(no EXIF info)"); expdisp->value(""); resdisp->value(""); }
 else {
  datedisp->value(m_exifinfo.DateTime);
  if (m_exifinfo.ExposureTime > 0.5) sprintf(exftmp,"f/%3.1f, %6.3f s", m_exifinfo.ApertureFNumber, m_exifinfo.ExposureTime);
  else sprintf(exftmp,"f/%3.1f, 1/%d s", m_exifinfo.ApertureFNumber, (int)(0.5 + 1.0/m_exifinfo.ExposureTime) );
  expdisp->value(exftmp);
  sprintf(exftmp,"%d x %d, %s",m_exifinfo.Width, m_exifinfo.Height, m_exifinfo.CameraModel);
  resdisp->value(exftmp);
 }

 if (dispimg) dispimg->release();
 dispimg=Fl_Shared_Image::get(path);    // !!? This may cause uncatchable access violation.
 if (!dispimg) resdisp->value("Couldn't load image.");
 display->value(dispimg);
 display->redraw();

 pull_caption();
 current_written=false;
}

int nWindow::pull_caption() {    // !!needs better return values
 if ( do_pull_db() ) {
  if ( do_pull_cfr() ) {
   if (!current_written) { caption->value(""); catrate->value(defcatr); }
   return false;
  }
 }
 return true;
}

char* nWindow::add_rootvalue(char* to, const char*append) {   //if path is relative, add root value to pre-allocated string
 if (append[0]=='/' || append[0]=='\\') strcpy(to,append);
 else if ( append[1]==':' && (append[2]=='/' || append[2]=='\\') ) strcpy(to,append); //check for drive letters
 else {
  strcpy(to,root->value());
  strcat(to,"/");
  strcat(to,append);
 }
 return to;
}

int nWindow::do_pull_db() {          //pull caption from database. return 0 on success, db err on failure
 int errc;
 sqlite3_stmt *prepped=0;
 const char* ptail=0;

#define SQL_PUL "SELECT caption, catrate FROM captions WHERE dir = ? AND file = ?"
 errc=sqlite3_prepare(db,SQL_PUL,strlen(SQL_PUL),&prepped,&ptail);
 if (errc!=SQLITE_OK) return errc;

 sqlite3_bind_text(prepped,1,root->value(),root->size(),SQLITE_TRANSIENT);
 sqlite3_bind_text(prepped,2,pathdisp->value(),pathdisp->size(),SQLITE_TRANSIENT);
 errc=sqlite3_step(prepped);
 if (errc!=SQLITE_ROW) return errc;

 caption->value((char*)sqlite3_column_text(prepped,0));
 catrate->value((char*)sqlite3_column_text(prepped,1));
 errc=sqlite3_step(prepped);
 sqlite3_finalize(prepped);
 if (errc!=SQLITE_DONE) { fl_message("Multiple captions found. Your caption database is so weird!"); return errc; }

 return 0;
}

int nWindow::do_pull_cfr() {         // read caption from captfile_r, return 0 on success
 char captloke[FL_PATH_MAX];
 char captfile_r[FL_PATH_MAX]; // !! need both captfile_r and captloke?
 char line[2*FL_PATH_MAX]; // !! size?
 bool done=false;
 char* ptr=0;
 FILE* capfile;
 const char* string=pathdisp->value();
 int add=0;

 prefs->get("captfile_r",captfile_r,"",sizeof(captfile_r));
 capfile=fopen(add_rootvalue(captloke,captfile_r),"r");
 if (!capfile) return -1;
 while( !done && fgets(line,2*FL_PATH_MAX,capfile) ) {
  done=true;
  for (int i=0; i<strlen(string); i++) {
   if (string[i]==line[i]) continue;
   if (string[i]=='/' && line[i]=='\\') continue;
   if (string[i]=='\\' && line[i]=='/') continue;
   if (string[i]>=65 && string[i]<= 90 && string[i]==line[i]-32) continue;
   if (string[i]>=97 && string[i]<=122 && string[i]==line[i]+32) continue;
   done=false;
   break;
  }
 }
 if (done) {
  ptr=(char*)memchr(line,'\n',2*FL_PATH_MAX);
  if (ptr) {
   ptr[0]='\0';
   if ( (ptr-1)[0]=='\r' ) (ptr-1)[0]='\0';           // !? only necessary reading DOS files on linux compiles
  }
  else fl_message("Caption found, but truncated!");

  if (lookcatrate) {
   add=1;
   ptr=(char*)memchr((char*)line+strlen(string)+add,' ',2*FL_PATH_MAX-strlen(string));    //set ptr to space after category/rating
   if (ptr) {
    ptr[0]='\0';			//! more proper way to do this?
    catrate->value(line+strlen(string)+1);
   }
  }
  else catrate->value("");

  if (ptr) {
   ptr[0]='\0';
   caption->value(line+strlen(string)+catrate->size()+1+add);
  }
 }
 fclose(capfile);
 return done ? 0 : 1;
}

void nWindow::out_dir(char* path) {
 dirent **list;
 int num;
 char dpath[FL_PATH_MAX];

 num=fl_filename_list(path, &list);
 for (int i=0; i<num; i++) {
  if ( !strcmp("./",list[i]->d_name) || !strcmp(".",list[i]->d_name) || !strcmp("../",list[i]->d_name) || !strcmp("..",list[i]->d_name) ) continue;
  strcpy(dpath,path);
  strcat(dpath,list[i]->d_name);
  if ( fl_filename_isdir(dpath) ) {
   if (!fl_filename_match(dpath,"*/")) strcat(dpath,"/");
   out_dir(dpath);
  }
  else if (fl_filename_match(dpath,"*.avi") || fl_filename_match(dpath,"*.jpg"))  { tree->add(dpath); filecount++; }
 }
 for (int i = num; i > 0;) free((void*)(list[--i]));
 free((void*)list);
}

void nWindow::apply_prefs() {
 prefs->get("defcatr",defcatr,"",sizeof(defcatr));
 prefs->get("lookcatrate",lookcatrate,0);
}

class PrefWindow : public Fl_Double_Window {
 Fl_Box* intro;
 Fl_File_Input* cfr;
 Fl_Button* bb;
 Fl_Check_Button* lookcatrate;
 Fl_Return_Button* save;
 Fl_Button* cancel;
 Fl_Preferences* prefs;

 static void bb_cb_(Fl_Widget *w,void*d) { ((PrefWindow*)d)->bb_cb(); }
 void bb_cb();
 static void cancel_cb_(Fl_Widget *w,void*d) { ((PrefWindow*)d)->hide(); }
 static void save_cb_(Fl_Widget *w,void*d) { ((PrefWindow*)d)->save_cb(); }
 void save_cb();
public:
 PrefWindow (char*l, Fl_Preferences* toprefs) : Fl_Double_Window (250,175,l) {
  prefs=toprefs;
  begin();
  intro=new Fl_Box(5,5,240,40,"If you haven't already captioned a picture, flCaptionater can look for it's caption in a text file.");
  intro->align(FL_ALIGN_INSIDE | FL_ALIGN_LEFT | FL_ALIGN_WRAP );
  cfr=new Fl_File_Input(5,75,220,35,"Read text-based captions from:");
  cfr->align( FL_ALIGN_TOP | FL_ALIGN_LEFT );
  bb=new Fl_Button(225,85,20,25,"...");
  bb->callback(bb_cb_,this);
  lookcatrate=new Fl_Check_Button(5,110,240,25,"File includes category/rating");
  save=new Fl_Return_Button(10,145,75,25,"Save");
  save->callback(save_cb_,this);
  cancel=new Fl_Button(155,145,75,25,"Cancel");
  cancel->callback(cancel_cb_,this);
  end();

  char buffer[FL_PATH_MAX];
  prefs->get("captfile_r",buffer,"",sizeof(buffer));
  cfr->value(buffer);
  lookcatrate->value(prefs->entryExists("lookcatrate"));
  set_modal();
  show(); 
 }
};

void nWindow::set_prefs() {
 PrefWindow bob("Text file captions",prefs);
 while (bob.shown()) Fl::wait();
 apply_prefs();
 pull_caption();
}

void PrefWindow::bb_cb() {
 //char* chosen;
 //chosen=fl_dir_chooser("Load all images contained in directory", "");

 Fl_Native_File_Chooser fb(Fl_Native_File_Chooser::BROWSE_FILE);
 fb.title("Select a caption file to read");
 fb.filter("*.txt");
 switch ( fb.show() ) {
  case 1:
   break;
  case -1:
   fl_message("Problem loading file!");
   break;
  default:
   cfr->value(fb.filename());
 }
}

void PrefWindow::save_cb() {
 prefs->set("captfile_r",cfr->value());
 if ( lookcatrate->value() ) prefs->set("lookcatrate",1);
 else prefs->deleteEntry("lookcatrate");
 prefs->flush();                        // write changes
 hide();
}


class ExportWindow : public Fl_Double_Window {
 sqlite3* db;
 Fl_Preferences* prefs;
 const char* rootdir;
 Fl_Round_Button* currdir;
 Fl_Round_Button* alldirs;
 Fl_Check_Button* stampdir;
 Fl_Check_Button* lookcatrate;
 Fl_Button* go;
 Fl_Button* cancel;
 static void go_cb_(Fl_Widget* w, void* d) { ((ExportWindow*)d)->go_cb(); }
 void go_cb();
 static void cancel_cb_(Fl_Widget* w, void* d) { ((ExportWindow*)d)->hide(); }
 void cancel_cb();
 int do_export(const char*);
 void load_prefs();
 void write_prefs();
public:
 ExportWindow (char*l, Fl_Preferences* to_prefs, sqlite3* to_db, const char* to_rootdir) : Fl_Double_Window (250,160,l) {
  prefs=to_prefs;
  db=to_db;
  rootdir=to_rootdir;

  begin();
  currdir=new Fl_Round_Button(5,5,240,25,"Export from current directory");
  currdir->type(FL_RADIO_BUTTON);
  alldirs=new Fl_Round_Button(5,30,240,25,"Export all captions in database");
  alldirs->type(FL_RADIO_BUTTON);
  stampdir=new Fl_Check_Button(5,60,240,25,"Write directory headers");
  lookcatrate=new Fl_Check_Button(5,90,240,25,"Include category/rating");
  go=new Fl_Button(10,130,75,25,"Export @->");
  go->callback(go_cb_,this);
  cancel=new Fl_Button(155,130,75,25,"Cancel");
  cancel->callback(cancel_cb_,this);
  callback(cancel_cb_,this);
  end();
  load_prefs();
  set_modal();
  show(); 
 }
};

void ExportWindow::go_cb() {
 Fl_Native_File_Chooser fc(Fl_Native_File_Chooser::BROWSE_SAVE_FILE);
 fc.title("Export caption file");
 //fc.filter("*.txt"); //!! not entirely useful yet
 if ( fc.show()==0) {
  do_export( fc.filename() );
  hide();
  write_prefs();
  fl_message("Export might have succeeded.");
 }
 else hide();
}

void ExportWindow::load_prefs() {
 if ( prefs->entryExists("exp/alldirs") ) {
  alldirs->value(true);
  //currdir->value(false);
 }
 else {
  currdir->value(true);
  //alldirs->value(false);
 }
 if ( prefs->entryExists("exp/stampdir") ) stampdir->value(true);
 if ( prefs->entryExists("exp/lookcatrate") ) lookcatrate->value(true);
}

void ExportWindow::write_prefs() {
 if ( alldirs->value() ) prefs->set("exp/alldirs",1);
 else prefs->deleteEntry("exp/alldirs");

 if ( stampdir->value() ) prefs->set("exp/stampdir",1);
 else prefs->deleteEntry("exp/stampdir");

 if ( lookcatrate->value() ) prefs->set("exp/lookcatrate",1);
 else prefs->deleteEntry("exp/lookcatrate");
}

int ExportWindow::do_export(const char* file) {
 int errc=0;
 sqlite3_stmt *prepped=0;
 const char* ptail=0;
 int i=0;
 char lastdir[FL_PATH_MAX]={""};
 FILE* capfile=0;

 capfile=fopen(file,"a");        // ?? add overwrite option?
 if (!capfile) return -1;

#define SQL_PLL "SELECT dir, file, catrate, caption FROM captions WHERE dir LIKE ? ORDER BY dir, file"
 errc=sqlite3_prepare(db,SQL_PLL,strlen(SQL_PLL),&prepped,&ptail);
 if (errc!=SQLITE_OK) return errc;
 if (alldirs->value()) sqlite3_bind_text(prepped,1,"%",strlen("%"),SQLITE_STATIC);
 else sqlite3_bind_text(prepped,1,rootdir,strlen(rootdir),SQLITE_TRANSIENT);

 errc=sqlite3_step(prepped);
 while ( errc==SQLITE_ROW ) {
   if ( strcmp((char*)sqlite3_column_text(prepped,0), lastdir) && stampdir->value() ) {
    if ( strcmp("",lastdir) ) fputc('\n', capfile);                                                           //blank line if after other files !! if appending, won't separate first directory
    fputs( (char*)sqlite3_column_text(prepped, 0), capfile );                                                 //write directory stamp if dir is changing and stamp option selected
    fputs(":\n", capfile);
   }
   else if ( !stampdir->value() && alldirs->value() ) fputs( (char*)sqlite3_column_text(prepped, 0), capfile );   //pre-pend directory for export of all with no stamps
   strcpy(lastdir,(char*)sqlite3_column_text(prepped,0));
   fputs ( (char*)sqlite3_column_text(prepped, 1), capfile );                                                 //write image filename
   if ( lookcatrate->value() ) {
    fputc(' ',capfile);
    fputs( (char*)sqlite3_column_text(prepped, 2), capfile );                                                 //write category and rating if set
   }
   fputc(' ',capfile);
   fputs( (char*)sqlite3_column_text(prepped, 3), capfile );                                                  //write the caption
   fputc('\n',capfile);
   errc=sqlite3_step(prepped);
 }
 if (errc != SQLITE_DONE) return errc;
 
 fclose(capfile);
 sqlite3_finalize(prepped);
}


void nWindow::export_cb() {
 ExportWindow bob("Export captions",prefs,db,root->value());
 while (bob.shown()) Fl::wait();
}

main (int argc, char*argv[]) {
 nWindow win(600,405,"flCaptionater",argc,argv);
 //win.show(argc,argv);
 return (Fl::run());
}


